# bdm::mmix Class Reference

Mixture of mpdfs with constant weights, all mpdfs are of equal RV and RVC. More...

## Detailed Description

Mixture of mpdfs with constant weights, all mpdfs are of equal RV and RVC.

`#include <emix.h>`

List of all members.

## Public Member Functions
| mmix ()
| Default constructor.
void | set_parameters (const vec &w0, const Array< shared_ptr< mpdf > > &Coms0)
| Set weights `w` and components `R`.
double | evallogcond (const vec &dt, const vec &cond)
| Shortcut for conditioning and evaluation of the internal epdf. In some cases, this operation can be implemented efficiently.
vec | samplecond (const vec &cond)
| Returns a sample from the density conditioned on `cond`, .
void | from_setting (const Setting &set)
| Load from structure with elements:.
virtual string | to_string ()
| This method returns a basic info about the current instance.
virtual void | to_setting (Setting &set) const
| This method save all the instance properties into the Setting structure.
virtual void | validate ()
| This method TODO.
Matematical operations
virtual mat | samplecond_m (const vec &cond, int N)
| Returns.
virtual vec | evallogcond_m (const mat &Dt, const vec &cond)
| Matrix version of evallogcond.
virtual vec | evallogcond_m (const Array< vec > &Dt, const vec &cond)
| Array<vec> version of evallogcond.
Access to attributes
const RV & | _rv () const
const RV & | _rvc () const
int | dimension () const
int | dimensionc ()
Connection to other objects
void | set_rvc (const RV &rvc0)
void | set_rv (const RV &rv0)
bool | isnamed ()
## Protected Member Functions
void | set_ep (epdf &iepdf)
| set internal pointer `ep` to point to given `iepdf`
void | set_ep (epdf *iepdfp)
| set internal pointer `ep` to point to given `iepdf`
## Protected Attributes
Array< shared_ptr< mpdf > > | Coms
| Component (mpdfs).
vec | w
| weights of the components
epdf | dummy_epdf
| dummy epdfs
int | dimc
| dimension of the condition
RV | rvc
| random variable in condition

## Member Function Documentation

void bdm::mpdf::from_setting | ( | const Setting & | set | ) | `[virtual, inherited]`

Load from structure with elements:.

             { class = "mpdf_offspring",
               rv = {class="RV", names=(...),}; // RV describing meaning of random variable
               rvc= {class="RV", names=(...),}; // RV describing meaning of random variable in condition
               // elements of offsprings
             }

Reimplemented from bdm::root.

Reimplemented in bdm::mepdf, bdm::mprod, bdm::mDirich, bdm::mlnorm< sq_T, TEpdf >, bdm::mgnorm< sq_T >, bdm::mgamma, bdm::migamma_ref, bdm::mlognorm, bdm::mlnorm< ldmat, enorm >, and bdm::mlnorm< chmat >.

vec bdm::mmix::samplecond | ( | const vec & | cond | ) | `[virtual]`

Returns a sample from the density conditioned on `cond`, .

Parameters:

  | cond | is numeric value of `rv`

Reimplemented from bdm::mpdf.

References Coms, and w.

mat bdm::mpdf::samplecond_m | ( | const vec & | cond,
|  | int | N |
| ) |  |  | `[virtual, inherited]`

Returns.

Parameters:

  | N | samples from the density conditioned on `cond`, .
  | cond | is numeric value of `rv`

Reimplemented in bdm::mpdf_internal< EPDF >, bdm::mpdf_internal< eDirich >, bdm::mpdf_internal< enorm< sq_T > >, bdm::mpdf_internal< elognorm >, bdm::mpdf_internal< TEpdf< sq_T > >, bdm::mpdf_internal< egamma >, bdm::mpdf_internal< enorm< ldmat > >, bdm::mpdf_internal< eiWishartCh >, bdm::mpdf_internal< eigamma >, and bdm::mpdf_internal< enorm< chmat > >.

References bdm::mpdf::samplecond().

void bdm::mmix::set_parameters | ( | const vec & | w0,
|  | const Array< shared_ptr< mpdf > > & | Coms0 |
| ) |  |  | `[inline]`

Set weights `w` and components `R`.

Todo:
  check if all components are OK

References bdm::RV::_dsize(), Coms, bdm::mpdf::dimc, dummy_epdf, bdm::mpdf::rvc, and w.

The documentation for this class was generated from the following files:

- emix.h
- emix.cpp